/* Outputs the original data set + B bootstrapped data sets + an additional 
 * B*B bootstrapped data sets coming from each of the B bootstrapped data sets.
 *
 *    dboot_data seed B < datafile 
 *
 * seed should be an integer and is used to set the random seed for the uniform
 * random number generator. 
 * 
 * For each of the B bootstrapped data sets, B additional bootstrapped data sets
 * are generated from them. The ordering of the output is 
 * 
 *   original data
 *   b1: bootstrap data set 1 of original data
 *           ....
 *   bB: bootstrap data set B of original data
 *   bootstrap data set 1 of data b1
 *           ....
 *   bootstrap data set B of data b1
 *   bootstrap data set 1 of data b2
 *           ....
 *   bootstrap data set B of data bB
 */
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
void dboot_seq_file(FILE *infile, FILE *outfile, int B);

int main(int argc, char **argv){
  int B;
  B = atoi(argv[--argc]);
  srand48(atoi(argv[--argc]));
  dboot_seq_file(stdin,stdout,B);
  return(0);
}
