#include <stdio.h>
#include <stdlib.h>
#include <math.h>

int l2i(char c){
  if (c == 'a' || c == 'A') return(0);
  if (c == 'c' || c == 'C') return(1);
  if (c == 'g' || c == 'G') return(2);
  if (c == 't' || c == 'T') return(3);
  if (c == '-') return(5);
  return(6);
}

char i2l(int i){
  switch(i){
  case 0:
    return('A');
  case 1:
    return('C');
  case 2:
    return('G');
  case 3:
    return('T');
  }
  return('E');
}

enum {
  alanine = 0, arginine, asparagine, aspartic, cysteine, 
  glutamine, glutamic, glycine, histidine, isoleucine,
  leucine, lysine, methionine, phenylalanine, proline,
  serine, threonine, tryptophan, tyrosine, valine
};

char i2lp(int i){
  switch(i){
  case 0:
    return('A');

  case 1:
    return('R');
  
  case 2:
    return('N');
 
  case 3:
    return('D');
 
  case 4:
    return('C');
 
  case 5:
    return('Q');
 
  case 6:
    return('E');
 
  case 7:
    return('G');
 
  case 8:
    return('H');
 
  case 9:
    return('I');
 
  case 10:
    return('L');
 
  case 11:
    return('K');
 
  case 12:
    return('M');
 
  case 13:
    return('F');
 
  case 14:
    return('P');
 
  case 15:
    return('S');
 
  case 16:
    return('T');
 
  case 17:
    return('W');
 
  case 18:
    return('Y');
 
  case 19:
    return('V');
    
  case 21:
    return('-');
    
  case 22:
    return('X');
    
  case 23:
    return('?');
  }
  return('Z');
}

int l2ip(char c){
  switch(c){
  case 'A':
    return(alanine);
    
  case 'R':
    return(arginine);
    
  case 'N':
    return(asparagine);
    
  case 'D':
    return(aspartic);

  case 'C':
    return(cysteine);

  case 'Q':
    return(glutamine);

  case 'E':
    return(glutamic);

  case 'G':
    return(glycine);

  case 'H':
    return(histidine);

  case 'I':
    return(isoleucine);

  case 'L':
    return(leucine);

  case 'K':
    return(lysine);

  case 'M':
    return(methionine);

  case 'F':
    return(phenylalanine);

  case 'P':
    return(proline);

  case 'S':
    return(serine);

  case 'T':
    return(threonine);

  case 'W':
    return(tryptophan);

  case 'Y':
    return(tyrosine);

  case 'V':
    return(valine);

  case '-':
    return(21);
    
  case 'X':
    return(22);

  case '?':
    return(23);
    /* future: cases X and ? represent unknown aa 
     * B - asparagine or aspartic
     * Z - glutamine or glutamic
     * * - stop codon
     */
  }
  return(100);
}

void rmgap(int numsp, int *nsite, char *seqc){
  int i,j,k,sp,newnsite;

  newnsite = *nsite;
  for(i = *nsite-1; i >= 0; i--)
    for(j = 0; j < numsp; j++)
      if (seqc[i + j*(*nsite)] == '-'){
	for(k = i; k < newnsite-1; k++)
	  for(sp = 0; sp < numsp; sp++)
	    seqc[k + sp*(*nsite)] = seqc[k+1 + sp*(*nsite)];
	newnsite--;
	break;
      }

  for(j = 1; j < numsp; j++)
    for(i = 0; i < newnsite; i++)
      seqc[i + j*newnsite] = seqc[i + j*(*nsite)];

  *nsite = newnsite;
}
/*----------------------------------------------------------------------------*/
int rmgap_pair(int nsite, int *s1, int *s2, int *seq1, int *seq2)
{
  int ns = 0, i;

  for(i = 0; i < nsite; i++){
    if (s1[i] < 20 && s2[i] < 20){
      seq1[ns] = s1[i];
      seq2[ns] = s2[i];
      ns++;
    }}
  return(ns);
}
/*------------------------------------------------------------------------*/
int rseq(char *seq){
  int rsite = 0;
  char c;

  while((c = getchar()) != '\n' &&  c != EOF){
    if (c != ' '){
      *seq = c;
      seq++;
      rsite++;
    }
  }
  return(rsite);
}

int rseqf(FILE *fp, char *seq){
  int rsite = 0;
  char c;

  while((c = getc(fp)) != '\n' &&  c != EOF){
    if (c != ' '){
      *seq = c;
      seq++;
      rsite++;
    }
  }
  return(rsite);
}

void rinterleave(int *numsp, int *nsite, char name[][11], char *seq)
{
  int lsite = 0, csite = 0, i, j, initb = 1;
  char c;
  
  scanf("%i %i", numsp, nsite); 
  while((c = getchar()) == ' ' || c == '\n' || c == '\r'){
  }
  while(c != EOF){
    if (initb){
      name[0][0] = c;
      for(j = 1; j < 10; j++) name[0][j] = getchar();
      name[0][10] = '\0';
      lsite = rseq(seq);
      for(i = 1; i < *numsp; i++){
	for(j = 0; j < 10; j++)name[i][j] = getchar();
	lsite = rseq(&seq[i*(*nsite)]);
	name[i][10] = '\0';
      }
      initb = 0;
      csite = lsite;
      if (csite >= *nsite) return;
    }
    else{
      seq[csite] = c;
      lsite = rseq(&seq[(csite+1)]);
      for(i = 1; i < *numsp; i++){
	lsite = rseq(&seq[csite+i*(*nsite)]);
      }
      csite += lsite;
      if (csite >= *nsite) return;
    }
    while((c = getchar()) == ' ' || c == '\n');
  }
}

void rinterleavef(FILE *fp, int *numsp, int *nsite, char name[][11], char *seq)
{
  int lsite = 0, csite = 0, i, j, initb = 1;
  char c;
  
  fscanf(fp, "%i %i", numsp, nsite); 
  while((c = getc(fp)) == ' ' || c == '\n' || c == '\r'){
  }
  while(c != EOF){
    if (initb){
      name[0][0] = c;
      for(j = 1; j < 10; j++) name[0][j] = getc(fp);
      name[0][10] = '\0';
      lsite = rseqf(fp, seq);
      for(i = 1; i < *numsp; i++){
	for(j = 0; j < 10; j++)name[i][j] = getc(fp);
	lsite = rseqf(fp,&seq[i*(*nsite)]);
	name[i][10] = '\0';
      }
      initb = 0;
      csite = lsite;
      if (csite >= *nsite) return;
    }
    else{
      seq[csite] = c;
      lsite = rseqf(fp,&seq[(csite+1)]);
      for(i = 1; i < *numsp; i++){
	lsite = rseqf(fp,&seq[csite+i*(*nsite)]);
      }
      csite += lsite;
      if (csite >= *nsite) return;
    }
    while((c = getc(fp)) == ' ' || c == '\n');
  }
}

/*------------------------------------------------------------------------*/
void rinterleavef_nolim(FILE *fp, const int *numsp, const int *nsite, 
			char name[][11], char *seq)
{
  int lsite = 0, csite = 0, i, j, initb = 1;
  char c;

  while((c = getc(fp)) == ' ' || c == '\n' || c == '\r'){
  }
  while(c != EOF){
    if (initb){
      name[0][0] = c;
      for(j = 1; j < 10; j++) name[0][j] = getc(fp);
      name[0][10] = '\0';
      lsite = rseqf(fp, seq);
      for(i = 1; i < *numsp; i++){
	for(j = 0; j < 10; j++)name[i][j] = getc(fp);
	lsite = rseqf(fp,&seq[i*(*nsite)]);
	name[i][10] = '\0';
      }
      initb = 0;
      csite = lsite;
      if (csite >= *nsite) return;
    }
    else{
      seq[csite] = c;
      lsite = rseqf(fp,&seq[(csite+1)]);
      for(i = 1; i < *numsp; i++){
	lsite = rseqf(fp,&seq[csite+i*(*nsite)]);
      }
      csite += lsite;
      if (csite >= *nsite) break;
    }
    while((c = getc(fp)) == ' ' || c == '\n');
  }
}

 
/*------------------------------------------------------------------------*/
void winterleavef(FILE *fp, int numsp, int nsite, char name[][11], char *seq)
{
  int nblock, i, j, k, l, kend; 

  nblock = nsite/60 + 1;
  
  fprintf(fp,"%i %i\n", numsp, nsite); 
  for(l = 0; l < nblock; l++){
    for(i = 0; i < numsp; i++){
      if (l == 0)
	for(j = 0; j < 10; j++) putc(name[i][j], fp);
      else
	for(j = 0; j < 10; j++) putc(' ', fp);
      if (l == nblock - 1)
	kend = nsite % 60;
      else
	kend = 60;
      for(k = 0; k < kend; k++){
	if (k % 10 == 0) putc(' ', fp);
	putc(seq[k + 60*l +  i*nsite], fp);
      }
      putc('\n', fp);
    }
    putc('\n', fp);
  }

}

void winterleave(int numsp, int nsite, char name[][11], char *seq)
{
  winterleavef(stdout, numsp, nsite, name, seq);
}

void letter(int numsp, int nsite, char *seq)
{
  int i, j;
  for(i = 1; i < numsp; i++)
    for(j = 0; j < nsite; j++)
      if (seq[j + i*nsite] == '.') seq[j + i*nsite]=seq[j];
}
/*----------------------------------------------------------------------------*/
void pchar_freq(int NCHAR, int nsite, int *s1, int *s2, double *pf)
{
  int i,j,nc=0;

  for(j = 0; j < NCHAR*NCHAR; j++) pf[j] = 0.0;

  for(i = 0; i < nsite; i++){
    if(s1[i] < NCHAR && s2[i] < NCHAR){
      pf[s1[i]+s2[i]*NCHAR]++;
      nc++;
    }
  }

  for(j = 0; j < NCHAR*NCHAR; j++) pf[j] /= nc;
}
/*----------------------------------------------------------------------------*/
void char_freq(int NCHAR, int numsp, int nsite, int *seq, double *freq)
{
  int i,j,nc=0;

  for(j = 0; j < NCHAR; j++){
    freq[j] = 0.0;
  }
  for(i = 0; i < nsite*numsp; i++){
    if(seq[i] < NCHAR){
      for(j = 0; j < NCHAR; j++){
	if (seq[i] == j) freq[j]++;
      }
      nc++;
    }
  }

  for(j = 0; j < NCHAR; j++){
    freq[j] /= nc;
  }
}
/*------------------------------------------------------------------------*/
void char_freq_count(int NCHAR, int numsp, int endsite, int *seq, int *count, 
		     double *freq)
{
  int i,j,nsite,k;

  for(j = 0; j < NCHAR; j++){
    freq[j] = 0.0;
  }
  nsite = 0;
  for(i = 0; i < endsite; i++){
    for(k = 0; k < numsp; k++){
      for(j = 0; j < NCHAR; j++){
	if (seq[i+k*endsite] == j) freq[j] += count[i];
      }
    }
    nsite += count[i];
  }

  for(j = 0; j < NCHAR; j++){
    freq[j] /= (nsite*numsp);
  }
}
/*----------------------------------------------------------------------------*/
int patt_freq(int numsp, int nsite, int *seq, int *count)
{
  int *s;
  int endsite,i,j,k,match;

  s = (int *) malloc((size_t) nsite*numsp*sizeof(int));
  endsite = 0;
  for(i = 0; i < nsite; i++){
    /* check for a match */
    match = 0;
    for(k = 0; k < endsite; k++){
      match = 1;
      for(j = 0; j < numsp; j++){
	if (seq[i+j*nsite] != s[j+k*numsp]){
	  match = 0;
	  break;
	}
      }
      if (match){
	count[k] += 1;
	break;
      }
    }
    
    /* if not a match, new element */
    if (!match){
      for(j = 0; j < numsp; j++) s[j+endsite*numsp] = seq[i+j*nsite];
      count[endsite] = 1;
      endsite++;
    }
  }

  for(j = 0; j < numsp; j++)
    for(i = 0; i < endsite; i++)
      seq[i+j*endsite] = s[j+i*numsp];

  free(s);
  return(endsite);
}
/*----------------------------------------------------------------------------*/
void ou2nu(int numsp, double *outreec, double *utreec)
{
  int *label,i,k,r,l;
  double tmp;

  label = (int *) malloc((size_t) numsp*sizeof(int));
  for(i = 0; i < numsp; i++) label[i] = i;
  for(i = 0; i < (numsp - 1); i++){
    r = (int) outreec[i*4];
    l = (int) outreec[1+i*4];
    utreec[i*4] = label[r];
    utreec[1+i*4] = label[l];
    utreec[2+i*4] = outreec[2+i*4];
    utreec[3+i*4] = outreec[3+i*4];
    label[r] = numsp+i;
    for(k=l; k < (numsp-i-1); k++) label[k]=label[k+1];
    if (utreec[i*4] > utreec[1+i*4]){ /* r < l on return */
      tmp = utreec[i*4]; utreec[i*4] = utreec[1+i*4]; utreec[1+i*4] = tmp;
      tmp = utreec[2+i*4]; utreec[2+i*4] = utreec[3+i*4]; utreec[3+i*4] = tmp;
    }
  }
  
  free(label);
}

void pr_utreec(FILE *fp, int ntaxa, double *utreec){
  int i;
  for(i = 0; i < ntaxa-1; i++) 
    fprintf(fp, "%i %i %f %f\n", (int) utreec[i*4], (int) utreec[1+i*4],
	   utreec[2+i*4], utreec[3+i*4]);
}

void pr_utreec_top(FILE *fp, int ntaxa, int *utreec){
  int i;
  for(i = 0; i < ntaxa-1; i++) 
    fprintf(fp, "%i %i\n", utreec[i*2], utreec[1+i*2]);
}

/*= make sure r < l in utreecs */
void rlord_utreec(int ntaxa, double *utreec){
  int i;
  double c;
  for(i = 0; i < ntaxa-1; i++)
    if (utreec[i*4] > utreec[1+i*4]){
      c = utreec[1+i*4];
      utreec[1+i*4] = utreec[i*4];
      utreec[i*4] = c;
      c = utreec[3+i*4];
      utreec[3+i*4] = utreec[2+i*4];
      utreec[2+i*4] = c;
    }
}

/*= print distance matrix */
void pr_distmat(FILE *fp, int numsp, char name[][11], double *dmat){
  /* only need upper triangle */
  int p1,p2;
  fprintf(fp, "%i\n", numsp);
  for(p1 = 0; p1 < numsp; p1++){
    fprintf(fp, "%s ", name[p1]);
    for(p2 = 0; p2 < p1; p2++) fprintf(fp, "%f ", dmat[p2 + p1*numsp]);
    fprintf(fp, "%f ", 0.0);
    for(p2 = p1+1; p2 < numsp; p2++) fprintf(fp, "%f ", dmat[p1 + p2*numsp]);
    fprintf(fp, "\n");
  }
}

/*= frequencies of amino acids */
void infilefreq(int nbin, int ntaxa, int nsite, int *seq, double *freq)
{
  /* binning/udistfbf.c */
  int i,j,nt;

  printf("%i nbin",nbin);
  nt = 0;
  for(j = 0; j < nbin; j++) freq[j] = 0.0;

  for(i = 0; i < nsite*ntaxa; i++)
    for(j = 0; j < nbin; j++)
      if (seq[i] == j){
	freq[j]++;
	nt++;
	break;
      }

  for(j = 0; j < nbin; j++) freq[j] /= nt;
}

/*= allocate memory, read in character seq data */
char *read_seqc(FILE *fp, int *ntaxa, int *nsite, char name[][11]){
  char *seqc;
  fscanf(fp, "%i %i",ntaxa,nsite); 
  seqc = (char *) malloc((size_t) (*ntaxa)*(*nsite)*sizeof(char));
  rinterleavef_nolim(fp,ntaxa,nsite,name,seqc);
  return(seqc);
}

/*= allocate memory, convert to int, optionally rmgap */
int *read_seq(FILE *fp, int *ntaxa, int *nsite, char name[][11], int rm_gap){
  int i,*seq;
  char *seqc;
  
  seqc = read_seqc(fp,ntaxa,nsite,name);
  letter(*ntaxa,*nsite,seqc);
  if (rm_gap) rmgap(*ntaxa,nsite,seqc);
  seq = (int *) malloc((size_t) (*ntaxa)*(*nsite)*sizeof(int));
  for(i = 0; i < (*nsite)*(*ntaxa); i++)
    seq[i] = l2ip(seqc[i]);
  free(seqc);
  return(seq);
}

/*= allocate memory, convert to int, optionally rmgap, dna data */
int *read_seq_dna(FILE *fp, int *ntaxa, int *nsite, char name[][11], 
		  int rm_gap){
  int i,*seq;
  char *seqc;
  
  seqc = read_seqc(fp,ntaxa,nsite,name);
  letter(*ntaxa,*nsite,seqc);
  if (rm_gap) rmgap(*ntaxa,nsite,seqc);
  seq = (int *) malloc((size_t) (*ntaxa)*(*nsite)*sizeof(int));
  for(i = 0; i < (*nsite)*(*ntaxa); i++)
    seq[i] = l2i(seqc[i]);
  free(seqc);
  return(seq);
}

/*= output distances to infile */
/* void dist_out(FILE *infile, int numsp, char name[][11], double *dmat){ */
/*   int p1,p2; */

/*   fprintf(infile,"%i\n", numsp); */
/*   for(p1 = 0; p1 < numsp; p1++){ */
/*     fprintf(infile,"%s", name[p1]); */
/*     for(p2 = 0; p2 < p1; p2++) fprintf(infile,"%f ", dmat[p2 + p1*numsp]); */
/*     fprintf(infile,"%f ", 0.0); */
/*     for(p2 = p1+1; p2 < numsp; p2++){ */
/*       fprintf(infile,"%f ", dmat[p1 + p2*numsp]); */
/*     } */
/*     fprintf(infile,"\n"); */
/*   } */
/* } */
