#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include "ealgc.h"

/*= remove excess space in names */
void rmexspce(int numsp, char names[][11]){
  int i,j;
  for(i = 0; i < numsp; i++)
    for(j = 10; j >= 0; j--)
      if (names[i][j] != ' ' && names[i][j] != '\0' &&  names[i][j] != '\t' && names[i][j] != '\r'){
	names[i][j+1] = '\0';
	break;
      }
}

/*= convert utreec (new) to Newick format */
void ut2n(int numsp, double *utreec, char names[][11], char *tstr){
  char **tstring;
  int i,len,r,l;

  tstring = (char **) malloc((size_t) (2*numsp-2)*sizeof(char *));

  for(i = 0; i < numsp; i++){
    len = lstring(names[i]);
    tstring[i] = (char *) malloc((size_t) len*sizeof(char));
    strcpy(tstring[i], names[i]);
  }

  for(i = 0; i < (numsp-3); i++){
    r = utreec[i*4]; l = utreec[1+i*4];
    len = lstring(tstring[r]) + lstring(tstring[l])+23; /* space for branch lengths in the 100s */
    tstring[i+numsp] = (char *) malloc((size_t) len*sizeof(char));
    sprintf(tstring[i+numsp],"(%s:%.5f,%s:%.5f)",tstring[r],utreec[2+i*4],tstring[l],
	    utreec[3+i*4]);
  }
  /* PHYLIP requires trifurcation */
  r = utreec[(numsp-3)*4]; l = utreec[1+(numsp-3)*4];
  len = lstring(tstring[r]) + lstring(tstring[l]) + 21;
  tstring[2*numsp-3] = (char *) malloc((size_t) len*sizeof(char));
  sprintf(tstring[2*numsp-3],"%s:%.5f,%s:%.5f",tstring[r],utreec[2+(numsp-3)*4],tstring[l],
	    utreec[3+(numsp-3)*4]);
  r = utreec[(numsp-2)*4]; l = utreec[1+(numsp-2)*4];
  r = (r < l)?r:l;
  sprintf(tstr,"(%s,%s:%.5f);",tstring[2*numsp-3],tstring[r],
	    utreec[2+(numsp-2)*4]+utreec[3+(numsp-2)*4]);
  len = lstring(tstr);
  tstr[len] = '\0';
  for(i = 0; i < 2*numsp-2; i++) free(tstring[i]);
  free(tstring);
}
